#include "netrun.h"
/* random */
#include <stdlib.h>
/* getpid */
#include <unistd.h>
/* time */
#include <time.h>

/*
 * A couple of random-number routines.
 */

/*
 * Throw some dice. Something tells me this isn't quite right.
 */
 
int dice(int number, int type)
{
    int i,j = 0;
    
    for (i = 0; i < number; i++)
    {
        j += number_range(1,type);
    }

    return j;
}

int one_in_(int j)
{
    return((number_range(1,j) == 1));
}

/*
 * Generate a random number. 
 */
int number_range(int from, int to)
{
    int power;
    int number;

    if (from == 0 && to == 0)
        return 0;

    if ((to = to - from + 1) <= 1)
        return from;

    for (power = 2; power < to; power <<= 1)
        ;

    while ((number = (random() >> 6) & (power - 1)) >= to)
        ;

    return from + number;
}

void init_random(void)
{
    /* Init random number generator */
    srandom(time(NULL)^getpid());        
}
