#include "netrun.h"

/*
 * Tables of various information.
 */

/* Server names. */

const char * server_names[MAX_LEVEL][MAX_NAMES]=
{
    {
        "a weeflerunner's BBS", /* HACK */
        "Boogie Board BBS",
        "City Hall",
        "D placeholder", /* HACK */
        "e placeholder", /* HACK */
        "F placerholder", /* HACK */
        "g Placeholder", /* HACK */
        "H placHolder", /* HACK */
        "iPlace holder", /* HACK */
        "Jack", /* HACK */
        "King", /* HACK */
        "League", /* HACK */
        "Municipal Uni",
        "No", /* HACK */
        "Ow.", /* HACK */
        "Public Hospital",
        "Quilcomm", /* HACK */
        "Rack", /* HACK */
        "S placeholder", /* HACK */
        "Telef BBS", /* HACK */
        "Unknown. No, really!", /* HACK */
        "Virtual Mall",
        "Wax", /* HACK */
        "Xenon's Fortress", /* HACK */
        "Y?", /* HACK */
        "Zac." /* HACK */
    },

    {
        "a private buisiness's", /* HACK */
        "b placeholder",
        "c placeholder",
        "d placeholder",
        "e placeholder",
        "f placeholder",
        "Goliath Weapons GmbH", /* HACK */
        "h placeholder",
        "i placeholder",
        "Justice Hall",
        "kLFMR", /* HACK */
        "l placeholder",
        "Mach.",
        "Net 42 News",
        "ObeComm",
        "placeholder", /* HACK */
        "Q Continuous", /* HACK */
        "r placeholder",
        "s placeholder",
        "Trauma Team",
        "Uni-Board BBS"
        "V placeholder",
        "W placeholder",
        "X placeholder",
        "Y placeholder",
        "Z placeholder"
    },

    {
        "a small Megacorp", /* HACK */
        "BeeCee BBS", 
        "c placeholder", /* HACK */
        "DefFX BBS",
        "e placeholder",
        "f placeholder",
        "Globalcomm",
        "Hunt Club BBS",
        "i placeholder",
        "j placeholder",
        "Kanuka, Warble and Smith",
        "lack of name", /* HACK */
        "Marakath Arms",
        "N placeholder",
        "O placeholder",
        "P placeholder",
        "Q placeholder",
        "R placeholder",
        "S placeholder",
        "T placeholder",
        "U placeholder",
        "V placeholder",
        "W placeholder",
        "X placeholder",
        "Y placeholder",
        "Z placeholder"
    },

    {
        "Air Orbital",
        "b placeholder",
        "c placeholder",
        "Disinformation Software",
        "e placeholder",
        "f placeholder",
        "Gack!", /* HACK */
        "Hate Place >:>, The", 
        "Infosoft",
        "Jameson BBS",
        "KCR", /* HACK */
        "large MegaCorp's", /* HACK */
        "Militech",
        "n placeholder",
        "o placeholder",
        "Parraline BBS",
        "q placeholder",
        "REO Meatwagon",
        "S placeholder",
        "Terra Labs",
        "U placeholder",
        "V placeholder",
        "W placeholder",
        "X placeholder",
        "Y placeholder",
        "ZetaTech"
    },

    {
        "Arasakin", /* HACK */
        "Big Black BBS :P",
        "Cerulean Investments",
        "Dark Angels BBS",
        "EBM",
        "f placeholder",
        "g placeholder",
        "h placeholder",
        "i placeholder",
        "j placeholder",
        "k placeholder",
        "l placeholder",
        "MicroTech",
        "NotAFortress BBS",
        "Open Hacker BBS",
        "Petrochem-BP",
        "QuestAThon",
        "r placeholder",
        "s placeholder",
        "T Pacemaker",
        "UniBank and Finance",
        "V placeholder",
        "W placeholder",
        "X placeholder",
        "Y placeholder",
        "Z placeholder"
    }
};


const int server_spoils_table [MAX_LEVEL + 1]=
{
    0,
    100,  /* Level 1 */
    200,  /* Level 2 */
    500,  /* Level 3 */
    1000, /* Level 4 */
    2000  /* Level 5 */
};

/* ICE */

const ICE_MASTER ice_table[16]=
{
    { 
        "Pin", "A pin darts at you.",                                                    
        FS_ANTI_U, 1
    },

    { 
        "Knife", "A knife whizzes out of the dark.",                                       
        FS_ANTI_U, 2
    },

    { 
        "Sword", "A glowing blue katana lashes out at you from nowhere.",                  
        FS_ANTI_U, 3
    },

    { 
        "Hellbolt", "A bolt of crimson fire is hurled at you.",                               
        FS_ANTI_U, 4
    },

    { 
        "Hellhound", "A huge, black metallic dog glares at you with green eyes and charges.",  
        FS_ANTI_U, 5
    },

    { 
        "Krash", "A beam of blue neon streaks out and hits you.",                      
        FS_ANTI_D, 1
    },

    { 
        "DecKrash", "A ray of green neon streaks out and hits you.",                      
        FS_ANTI_D, 2
    },

    { 
        "Flatline", "A cartoon anarchist bomb appears and explodes in your face.",       
        FS_ANTI_D, 3
    },

    { 
        "Zap", "A lightning bolt appears and explodes in your face.",               
        FS_ANTI_D, 4
    },

    { 
        "Firestarter", "A pillar of fire appears, screams incoherently, and leaps at you.", 
        FS_ANTI_D, 5
    },

    { 
        "Thug", "It appears behind your %s and gets it in a headlock.",              
        FS_ANTI_P, 1
    },

    { 
        "Killer II", "A samurai rezzes, and charges your %s with a glowing blue katana.", 
        FS_ANTI_P, 2
    },

    { 
        "Hitman", "A shifty man with a sniper rifle fires at your %s from a ledge.",   
        FS_ANTI_P, 3
    },

    { 
        "Killer IV", "A samurai rezzes, and charges your %s with a neon green katana.",   
        FS_ANTI_P, 4
    },
    
    { 
        "'Chaos'", "A black android armed with a shiny black rifle attacks your %s.",    
        FS_ANTI_P, 5
    },
    
    {
        NULL, NULL,
        FS_ANTI_P, 0
    }
};

const ICE_TYPE_LIST ice_type_list[4]=
{
    { FS_ANTI_P, S_ANTI_P, "A-P", ice_anti_program },
    { FS_ANTI_D, S_ANTI_D, "A-D", ice_anti_deck },
    { FS_ANTI_U, S_ANTI_U, "A-U", ice_anti_user },
    { FS_ANTI_U, S_ANTI_U, NULL, NULL }
};

const int program_size_table [MAX_STR]=
{
    1,
    1,
    2,
    3,
    4,
};

const int program_cost_table[MAX_STR]=
{
   500,   /*  100,  250 */
   1000,  /*  200,  500 */
   2000,  /*  400, 1000 */
   5000,  /* 1000, 2500 */
   10000  /* 2000, 5000 */
};

/* Armor */

const int armor_cost_table [MAX_ARMOR + 1]=
{    
    0,
    2000,
    2000,
    2000,
    2000,
    2000
};

/* Runner ranks */
const char * rank_name_table [MAX_RANK + 1]=
{
    "Weeflerunner",
    "Sysop",
    "Corporate 'runner",
    "Freelance 'runner",
    "Master Netrunner",
    "Netrunner Legend"
};

const int rank_cost_table [MAX_RANK + 1]=
{
    0,
    10000,
    10000,
    10000,
    10000,
    10000
};

const char * house_name_table[MAX_RANK + 1]=
{
    "'coffin'",
    "flop-cube",
    "small flat",
    "decent flat",
    "high-rise apartment",
    "penthouse condo"
};

const char * food_name_table[MAX_RANK + 1]=
{
    "some kibble",
    "a freeze-dried meal",
    "a Realpack",
    "a fresh meal",
    "a big meal",
    "a two-course meal"
};

const char * car_name_table[MAX_RANK + 1]=
{
    "on foot",
    "on foot",
    "by motorscooter",
    "by car",
    "with a bodyguard",
    "in a chauffered limo"
};

/* Directions */
const char * dir_name_table [MAX_DIR]=
{
    "north",
    "east",
    "south",
    "west"
};

const util_type util_table[]=
{
    { "Repair",     UTIL_REPAIR,    2500  },
    { "Virus Scan", UTIL_VIRUSSCAN, 5000  },
    { "Anti-Virus", UTIL_ANTIVIRUS, 10000 },
    { "News",       UTIL_NEWS,      1000  },
    { "Rankings",   UTIL_RANKINGS,  2000  },
    { "Fake",       UTIL_FAKE,      1    },
    { "AI-L",       UTIL_AIL,       1    },
    { NULL,         0,              0    }
}; 

const char layout_table[MAX_LAYOUTS][MAX_ROOMS_X][MAX_ROOMS_Y]=
{
    {
        {'/', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '/'},
        {' ', ' ', '#', '#', '+', '#', '#', ' ', ' '},
        {' ', '#', '*', '.', '-', '.', '*', '#', ' '},
        {' ', '#', '.', '#', '-', '#', '.', '#', ' '},
        {' ', '+', '-', '-', '*', '-', '-', '+', ' '},
        {' ', '#', '.', '#', '-', '#', '.', '#', ' '},
        {' ', '#', '*', '.', '-', '.', '*', '#', ' '},
        {' ', ' ', '#', '#', '+', '#', '#', ' ', ' '},
        {'/', ' ', ' ', ' ', '@', ' ', ' ', ' ', '/'}
    },

    {
        {'/', '/', '/', '/', '/', '/', '/', '/', '/'},
        {'/', '/', '/', ' ', ' ', ' ', ' ', ' ', '/'},
        {' ', ' ', ' ', ' ', ' ', '#', ' ', ' ', '/'},
        {' ', ' ', '#', '#', '#', '*', '#', ' ', '/'},
        {'@', '+', '-', '-', '-', '.', '#', ' ', '/'},
        {' ', ' ', '#', '#', '#', '*', '#', ' ', '/'},
        {' ', ' ', ' ', ' ', ' ', '#', ' ', ' ', '/'},
        {'/', '/', '/', ' ', ' ', ' ', ' ', ' ', '/'},
        {'/', '/', '/', '/', '/', '/', '/', '/', '/'}
    },

    {
        {'/', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '/'},
        {' ', ' ', '#', '#', '#', '#', '#', ' ', ' '},
        {' ', '#', '-', '.', '-', '.', '-', '#', ' '},
        {' ', '#', '.', '*', '+', '*', '.', '#', ' '},
        {' ', '#', '|', '#', '@', '#', '|', '#', ' '},
        {' ', '#', '.', '#', ' ', '#', '.', '#', ' '},
        {' ', '#', '*', '#', ' ', '#', '*', '#', ' '},
        {' ', ' ', '#', ' ', ' ', ' ', '#', ' ', ' '},
        {'/', ' ', ' ', ' ', '/', ' ', ' ', ' ', '/'}
    },
/*    
    {
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '}
    },
*/    
    {
        {'/', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '},
        {'/', ' ', '#', ' ', '@', '#', '#', '#', ' '},
        {'/', ' ', ' ', '#', '+', '-', '-', '+', ' '},
        {' ', ' ', '#', '.', '-', '.', '.', '#', ' '},
        {' ', '#', '*', '-', '.', '#', '-', '+', ' '},
        {' ', ' ', '#', '#', '.', '.', '.', '#', ' '},
        {'/', ' ', ' ', '#', '|', '.', '#', '#', ' '},
        {'/', '/', ' ', ' ', '#', '#', ' ', ' ', ' '},
        {'/', '/', '/', ' ', ' ', ' ', ' ', '/', '/'}
    },

    {
        {' ', ' ', ' ', ' ', ' ', ' ', ' ', '/', '/'},
        {' ', '#', '#', '+', '#', '#', ' ', ' ', '/'},
        {' ', '#', '.', '-', '-', '.', '#', ' ', '/'},
        {' ', '#', '*', '.', '#', '|', '#', ' ', '/'},
        {' ', ' ', '#', '-', '*', '#', ' ', ' ', '/'},
        {' ', '#', '-', '.', '.', '.', '#', ' ', '/'},
        {' ', '#', '+', '#', '#', '-', '+', ' ', '/'},
        {' ', ' ', '@', ' ', ' ', '#', '#', ' ', '/'},
        {'/', '/', '/', '/', ' ', ' ', ' ', ' ', '/'}
    }
};

/*
 * The master program list. Name, action, type, cost, etc.
 */

const PROGRAM_MASTER program_list[1000]=
{
    /*
     * Anti-Program 
     */

    {
        "Thug", "It appears behind the %s and gets it in a headlock.", 
        P_ANTI_P, 1, 2500,
    },
    
    
    {
        "Killer II", "A samurai rezzes, and charges %s with a glowing blue katana.", 
        P_ANTI_P, 2, 5000, 
    },

    {
        "Hitman", "A shifty man with a sniper rifle fires at %s from a ledge.",
        P_ANTI_P, 3, 10000, 
    },

    {
        "Killer IV", "A samurai rezzes, and charges %s with a neon green katana.",
        P_ANTI_P, 4, 25000, 
    },

    {
        "'Axe'", "An odd-looking person armed with a pale green axe takes a swipe at %s.",
        P_ANTI_P, 5, 50000, 
    },

    /*
     * Intrusion
     */

    {
        "Crowbar", "You jam it in a crack in the %s Data Wall.",
        P_INTR, 1, 500, 
    },

    {
        "Pick", "You start to hack away at the %s Data Wall.",
        P_INTR, 2, 1000, 
    },

    {
        "Hammer", "A glowing red sledgehammer appears, and hits the %s Data Wall.",
        P_INTR, 3, 2000, 
    },

    {
        "Jackhammer", "A neon yellow jackhammer appears, and fires a stream of white flashes at the %s Data Wall.",
        P_INTR, 4, 5000, 
    },

    {
        "'Charges'", "You put a small block of plastic at the bottom of the %s Data Wall, and run.",
        P_INTR, 5, 10000, 
    },

    /*
     * Decryption
     */

    {
        "Stethoscope", "You apply it to the %s codegate.",
        P_DECR, 1, 500, 
    },

    {
        "Ultrasounder", "You point a small black box at the %s codegate.",
        P_DECR, 2, 1000, 
    },

    {
        "Codecracker", "A glowing white fog envelopes the %s codegate.",
        P_DECR, 3, 2000,
    },

    {
        "Wizard's Book", "A blazing stream of glyphs hits the %s codegate.",
        P_DECR, 4, 5000,
    },

    {
        "Raffles", "A dapper young man in formal dress walks up to the %s codegate.",
        P_DECR, 5, 10000,
    },

    /*
     * Protection
     */

    {
        "Buckler", "You prepare to block ICE blows with a tiny shield.",
        P_PROT, 1, 500,
    },

    {
        "Reflector", "A two-foot mirror appears in the air before you.",
        P_PROT, 2, 1000,
    },

    {
        "Shield", "It rezzes in your hands.",
        P_PROT, 3, 2000,
    },

    {
        "Force Shield", "A shimmering circle of light appears in the air.",
        P_PROT, 4, 5000,
    },

    {
        "Force Armor", "You are covered in a glowing skin.",
        P_PROT, 5, 10000, 
    },

    /*
     * Stealth
     */

    {
        "Sideslip", "You start darting behind stray files.",
        P_STEALTH, 1, 1000, 
    },

    {
        "Duck", "You sneak along, ducking behind protrusions.",
        P_STEALTH, 2, 2000, 
    },

    {
        "Invisibility", "You start flickering unseen...",
        P_STEALTH, 3, 4000, 
    },

    {
        "Stealth", "You sneak behind the program.",
        P_STEALTH, 4, 10000, 
    },

    {
        "Formless", "Your ICON disappears.",
        P_STEALTH, 5, 20000, 
    },

    /*
     * Information
     */

    { 
        "Contacts",  "",
        P_INFO, 1, 0, 
    },

    {
        "Valuable Rumors", "",
        P_INFO, 2, 0,  
    },

    {
        "Newtech Design", "",
        P_INFO, 3, 0,  
    },

    {
        "Grey Ops", "",
        P_INFO, 4, 0,  
    },

    {
        "Black Ops", "",
        P_INFO, 5, 0,  
    },

    /*
     * Cheque files.
     */
    /* UNFIN Need better names! */

    {
        "Order Cheque", "",
        P_CRED, 1, 0,  
    },

    {
        "Loan Payment", "",
        P_CRED, 2, 0, 
    },

    {
        "Hardware Order", "",
        P_CRED, 3, 0,  
    },

    {
        "Bond Package", "",
        P_CRED, 4, 0, 
    },

    {
        "Share Portfolio", "",
        P_CRED, 5, 0,  
    },

    /* 
     * NULL (the sentinel) 
     */

    {
        NULL, NULL,
        P_CRED, 0, 0, 
    }

};

/* HACK Must be updated with enums. */
const PROGRAM_TYPE_LIST program_type_list[8]=
{
    { "FP_ANTI_P",  FP_ANTI_P,  P_ANTI_P,  "A-P", program_anti, program_no_use_netspace }, 
    { "FP_INTR",    FP_INTR,    P_INTR,    "INT", program_intr, program_no_use_netspace },
    { "FP_DECR",    FP_DECR,    P_DECR,    "DEC", program_decr, program_no_use_netspace },
    { "FP_PROT",    FP_PROT,    P_PROT,    "PRT", program_prot, program_no_use_netspace  },
    { "FP_STEALTH", FP_STEALTH, P_STEALTH, "STE", program_stealth, program_no_use_netspace  },
    { "FP_INFO",    FP_INFO,    P_INFO,    "INF", program_info, program_info },
    { "FP_CRED",    FP_CRED,    P_CRED,    "CRD", program_cred, program_cred },
    /* Sentinel */
    { NULL,         FP_CRED,    P_CRED,    NULL,  NULL, NULL }
};

/* HACK Must be updated with enums. */
const NETSPACE_TYPE_LIST netspace_type_list[]=
{
    { '1', N_LEVEL_1 },
    { '2', N_LEVEL_2 },
    { '3', N_LEVEL_3 },
    { '4', N_LEVEL_4 },
    { '5', N_LEVEL_5 },
    { '|', N_NS },
    { '-', N_EW },
    { '+', N_TEE },
    { ' ', N_NONE }
};

const char netspace_layout[17][17]=
{

    {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', ' ', '2', ' ', '3', ' ', '4', ' ', '4', ' ', '3', ' ', '2', ' ', '1', ' ' },
    {' ', ' ', '+', '-', '-', '-', '-', '-', '5', '-', '-', '-', '-', '-', '+', ' ', ' ' },
    {' ', '2', '|', '1', ' ', '2', ' ', '4', '|', '4', ' ', '2', ' ', '1', '|', '2', ' ' },
    {' ', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', ' ' },
    {' ', '3', '|', '2', ' ', '5', ' ', '2', '|', '2', ' ', '5', ' ', '2', '|', '3', ' ' },
    {' ', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', ' ' },
    {' ', '4', '|', '4', ' ', '2', ' ', '1', '|', '1', ' ', '2', ' ', '4', '|', '4', ' ' },
    {' ', ' ', '5', '-', '-', '-', '-', '-', '*', '-', '-', '-', '-', '-', '5', ' ', ' ' },
    {' ', '4', '|', '4', ' ', ' ', ' ', '1', '|', '1', ' ', '2', ' ', '4', '|', '4', ' ' },
    {' ', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', ' ' },
    {' ', '3', '|', '2', ' ', '5', ' ', '2', '|', '2', ' ', '5', ' ', '2', '|', '3', ' ' },
    {' ', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', '3', ' ', '3', ' ', '|', ' ', ' ' },
    {' ', '2', '|', '1', ' ', '2', ' ', '4', '|', '4', ' ', '2', ' ', '1', '|', '2', ' ' }, 
    {' ', ' ', '+', '-', '-', '-', '-', '-', '5', '-', '-', '-', '-', '-', '+', ' ', ' ' },
    {' ', '1', ' ', '2', ' ', '3', ' ', '4', ' ', '4', ' ', '3', ' ', '2', ' ', '1', ' ' },
    {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' }   
/*
    {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '5', '5', '5', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '4', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '3', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '3', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '3', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '3', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '5', '4', '3', '4', '5', ' ', ' ', ' ', ' ', ' ' },
    {' ', ' ', ' ', ' ', ' ', ' ', '*', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '3', '2', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '3', '2', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '3', '2', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '3', '2', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '3', '2', '1', ' ', ' ', ' ', ' ', ' ' }, 
    {' ', '1', '2', '3', '4', '5', ' ', '1', '2', '2', '2', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', '1', '2', '3', '4', '5', ' ', '1', '1', '1', '1', '1', ' ', ' ', ' ', ' ', ' ' },
    {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ' }   
*/
};

const SERVER_LEVEL_LIST server_level_list[]=
{
    { N_LEVEL_1, 1, "grey", "Grey", "LEVEL_1" },
    { N_LEVEL_2, 2, "level 1", "Lv. 1", "LEVEL_2" },
    { N_LEVEL_3, 3, "level 2", "Lv. 2", "LEVEL_3" },
    { N_LEVEL_4, 4, "level 3", "Lv. 3", "LEVEL_4" },
    { N_LEVEL_5, 5, "black", "Black", "LEVEL_5" },
    { N_NONE, 0, NULL, NULL, NULL },
};







