#include "netrun.h"
/* srandom */
#include <stdlib.h>

/* The nulls are just in case - they are (should be) initialised again. */
RUNNER_DATA * runner = NULL;
SERVER_DATA * server = NULL;
running_state next_action = ST_DONE;
where_state where = W_START;
WINDOW * title = NULL;
WINDOW * display = NULL;
WINDOW * programs = NULL;
WINDOW * menus = NULL;
WINDOW * descs = NULL;
WINDOW * errs = NULL;
WINDOW * inputs = NULL;
WINDOW * bottom = NULL;
WINDOW * player_stats = NULL;
int server_x = 0;
int server_y = 0;
bool running = FALSE;
/* HACK */
int net_size_x = 17;
int net_size_y = 17;
//NETSPACE_DATA netspace[NET_MAX_X][NET_MAX_Y];
NETSPACE_DATA ** netspace;
int start_net_x = (17 / 2); // HACK
int start_net_y = (17 / 2); // HACK
FILE * pLog = NULL;

WINDOW * pr_window = NULL; /* The window currently being worked on by pr(). */

char * save_file;

void main (void)
{
    init_output();
    init_random();
    
    /* HACK */
    save_file = strdup("foo.sav");

    /* Obligatory splash screen. */
    splash_screen();
    
    where = W_START;

    /* Main processing loop */
    while(TRUE)
    {    
        switch(where)
        {
            case W_START:
                /* Start up game - load game, new game, etc. */
                do_start();
                break;
            case W_HOME:
                do_home(runner);
                break;
            case W_STREET:
                do_street(runner);
                break;
            case W_NETSPACE:
                do_netspace(runner);
                break;
            case W_SERVER:
                do_running(runner);
                break;
            case W_END:
                exit_properly();
                break;
        }
    }

    /* Exit (this bit of code should never be reached... */    
    bug("main: wierd exit");
    exit_properly();
}
    
void exit_properly(void)
{
    write_game("foo.sav");
 
    if (server != NULL)
        free_server_data(server);
    /* UNFIN will not deallocate programs! */
    if (runner != NULL)
        free_runner_data(runner);

    stop_output();    
    exit(1);    
}










