#include "netrun.h"
/* usleep */
#include <unistd.h>

/* HACK */
/* Ugly hack to get arond cfunctions not parsing a double backslash correctly.
   Credits to Valrejn on #afd. */
char backslashstring[2] = {92, 0};

/* Waits until a keystroke, with a '-' twiddler. If the keystroke is ^L, refresh screen and continue, otherwise exit function. */
void morewait(void)
{
    bool repeat;
    char choice;
    char buf[200];
    int status;
    char * spin;

    /* So the function will tick on in 'real-time' rather than waiting on a keystroke, so the ticker ticks. */    
    nodelay(inputs, TRUE);

    status = 0;
    
    repeat = TRUE;
    while(repeat)
    {
        /* Get current character. */
        switch(status)
        {
            case 0:
                spin = "-";
                break;
            case 1: 
                spin = backslashstring; //"\092"; /* Aagh! */
                break;
            case 2:
                spin = "|";
                break;
            case 3:
                spin = "/";
                break;
        }
        
        /* Switch to the next character in the twiddler seqence. */
        if (status == 3)
        {
            status = 0;
        }
        else 
        {
            status++;
        }

        /* 'Um, what's that twiddler for?' :) */        
        sprintf(buf, "  More %s  ", spin);
        
        /* HACK Hardcoded screen width. Maybe make it yank the number via getmaxyx(). */
        /* Display the twiddler, and wait a (tiny) bit. */
        wmove(inputs, 0, 80 - strlen(buf));
        waddstr(inputs, buf);
        wrefresh(inputs);
        usleep(50000);
//        usleep(200000);

        /* Get keystroke. */        
        choice = wgetch(inputs);
        
        /* If we _got_ a keystroke: */
        if (choice != ERR)
        {
            /* HACK Nonportable, wrong way of checking for ^L */
            if (choice == 12)
            {
                wrefresh(stdscr);
            }
            else
            {
                /* Valid keypress, get the heck out */
                repeat = FALSE;
            }
        }
    }

    /* Set it back to normal. */            
    nodelay(inputs, FALSE);
    
    err_blank();
    
    return;
}

#define kill_that_window(a) if (a != NULL) {werase(a); wrefresh(a); delwin(a); a = NULL;}

void running_on(void)
{
    if (!is_running())
    {
        kill_that_window(menus);
        
        /* HACK hardcoded constants */
        display = newwin(14,28,1,2);
        
        menus = newwin(10,16,1,30);
        player_stats = newwin(5,16,11,30);        

        programs = newwin(14,32,1,46);

        descs = newwin(5,80,17,0);

        running = TRUE;
    }
}


void running_off(void)
{
    if (is_running())
    {
        kill_that_window(display);
        kill_that_window(menus);
        kill_that_window(programs);
        kill_that_window(descs);
        kill_that_window(player_stats);

        /* HACK hardcoded constants - these must also be changed in init_stuff() */
        menus = newwin(20,80,1,0);
        
        player_stats = newwin(1,80,21,0);

        running = FALSE;
    }
}

/* A simple word-wrapper. */
/* HACK UNFIN I _know_ there's ways this can be made better, even without creeping featuritis. */
char * word_wrap (const char * left_hanging, const char * left_indent, const char * input, const int line_length)
{
    int along_line;
    int along_input;
    int along_output;
    /* Should really have a dynamic buffer. Whatever. */
    static char output[10000];
    
    if ((left_hanging == NULL)||(left_indent == NULL)||(input == NULL)||(line_length <= 0))
        return "";

    if ((strlen(left_hanging) >= line_length) ||  (strlen(left_indent) >= line_length))
        return "";
    
    output[0] = '\0';
    
    along_line = 0;
    along_input = 0;
    along_output = 0;
    
    if (!!strcmp(left_hanging,""))
    {
        int i;
        
        for (i = 0; i < strlen(left_hanging); i++)
        {
            output[along_output] = left_hanging[i];
            along_output++;            
            along_line++;                
        }
    }
    
    while((input[along_input] != '\0')||(input[along_input] != '\n'))
    {
        {
            int word_len = 0;
        
            /* Get the length of the next word */
            while((input[along_input + word_len] != ' ') && (input[along_input + word_len] != '\0'))
            {
                word_len++;
            }
            
            /* If the length of the next word plus the distance along the line is greater than the line's length, add a carriage return to the output. */
            if ((along_line + word_len) > line_length)
            {               
                output[along_output] = '\n';
                along_output++;
                
                if (!!strcmp(left_indent,""))
                {
                    int i;
                    
                    for (i = 0; i < strlen(left_indent); i++)
                    {
                        output[along_output] = left_indent[i];
                        along_output++;            
                        along_line++;                
                    }
                }
                
                along_line = 0;
            }        
        }
        
        /* Put the word into the output buffer, moving up the along_input in the process. */
        /* HACK ' ' isn't the only word-breaker. */
        while((input[along_input] != ' ') && (input[along_input] != '\0'))
        {
            output[along_output] = input[along_input];
            along_output++;            
            along_input++;
            along_line++;

            if (input[along_input] == '\n')
            {
                output[along_output] = '\n';
                along_output++;
                output[along_output] = '\0';
                along_output++;
            
                return output;
            }
        }
        
        
        /* HACK So it also does the space. */
        
        if ((input[along_input] == ' ') && (input[along_input] != '\0'))
        {
            output[along_output] = input[along_input];
            along_output++;        
            along_input++;
            along_line++;

            if (input[along_input] == '\n')
            {
                output[along_output] = '\n';
                along_output++;
                output[along_output] = '\0';
                along_output++;
            
                return output;
            }
        }                
    }
    
    output[along_output] = '\n';
    along_output++;
    output[along_output] = '\0';
    along_output++;

    return output;    
}

/* Nice, hackish centerer. Even with variable padding! :) */
char * cline(char * message, char * lbracket, char * rbracket, char * dash, int width)
{
    int i,a;
    char buf[100];
    static char buf2[100];
   
    if ((lbracket == NULL)
    || (rbracket == NULL)
    || (dash == NULL)
    || (message == NULL))
    {
        bug("cline: bad args\n");
        return "";
    }
     
    buf[0] = '\0';
    buf2[0] = '\0';
            
    if (!strcmp(message,""))
    {
        strcat(buf,lbracket);

        for (i = 0; i < (width - (strlen(lbracket) + strlen(rbracket))); i++)
        {
            strcat(buf,dash);
        }
        
        strcat(buf,rbracket);
        
        strcpy(buf2,buf);
        
        return buf2;
    }
    
    strcat(buf,lbracket);
    
    a = (width - (strlen(lbracket) + strlen(rbracket))) - strlen(message);
    a /= 2;
    
    for (i = 0; i < a; i++)
    {
        strcat(buf,dash);
    }
    
    strcat(buf,message);
    
    for (i = 0; i < a; i++)
    {
        strcat(buf,dash);
    }
    
    if(((width - (strlen(lbracket) + strlen(rbracket))) - strlen(message)) % 2)
    {
        strcat(buf,dash);
    }    
    
    strcat(buf,rbracket);
    
    strcpy(buf2,buf);
    
    return buf2;    
}

